Instalación de rtorrent y wtorrent en Ubuntu 10.10
1. Instalamos rtorrent y algunas dependencias:
$ sudo apt-get install rtorrent screen mc wget gawk sqlite unzip php5-curl
2. Añadimos rtorrent para que arranque al principio:
$ sudo touch /etc/init.d/rtorrent $ sudo nano /etc/init.d/rtorrent
Nota: ctrl+o (guardar), ctrl+x (salir)
Ahora pegamos los siguiente:
#!/bin/bash
### BEGIN INIT INFO
# Provides: rtorrent
# Required-Start: $network
# Required-Stop: $network
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Start rtorrent as a daemon
### END INIT INFO
#!/bin/sh
#############
###<Notes>###
#############
# This script depends on screen.
# For the stop function to work, you must set an
# explicit session directory using ABSOLUTE paths (no, ~ is not absolute) in your rtorrent.rc.
# If you typically just start rtorrent with just "rtorrent" on the
# command line, all you need to change is the "user" option.
# Attach to the screen session as your user with
# "screen -dr rtorrent". Change "rtorrent" with srnname option.
# Licensed under the GPLv2 by lostnihilist: lostnihilist _at_ gmail _dot_ com
##############
###</Notes>###
##############
#######################
##Start Configuration##
#######################
# You can specify your configuration in a different file
# (so that it is saved with upgrades, saved in your home directory,
# or whateve reason you want to)
# by commenting out/deleting the configuration lines and placing them
# in a text file (say /home/user/.rtorrent.init.conf) exactly as you would
# have written them here (you can leave the comments if you desire
# and then uncommenting the following line correcting the path/filename
# for the one you used. note the space after the ".".
# . /etc/rtorrent.init.conf
#Do not put a space on either side of the equal signs e.g.
# user = user
# will not work
# system user to run as
user="rt"
# the system group to run as, not implemented, see d_start for beginning implementation
# group=`id -ng "$user"`
# the full path to the filename where you store your rtorrent configuration
config="/home/${user}/.rtorrent.rc"
# set of options to run with
options=""
# default directory for screen, needs to be an absolute path
#base="/home/${user}"
base="/home/rt"
# name of screen session
srnname="rtorrent"
# file to log to (makes for easier debugging if something goes wrong)
logfile="/var/log/rtorrentInit.log"
#######################
###END CONFIGURATION###
#######################
PATH=/usr/bin:/usr/local/bin:/usr/local/sbin:/sbin:/bin:/usr/sbin
DESC="rtorrent"
NAME=rtorrent
DAEMON=$NAME
SCRIPTNAME=/etc/init.d/$NAME
checkcnfg() {
exists=0
for i in `echo "$PATH" | tr ':' '\n'` ; do
if [ -f $i/$NAME ] ; then
exists=1
break
fi
done
if [ $exists -eq 0 ] ; then
echo "cannot find rtorrent binary in PATH $PATH" | tee -a "$logfile" >&2
exit 3
fi
if ! [ -r "${config}" ] ; then
echo "cannot find readable config ${config}. check that it is there and permissions are appropriate" | tee -a "$logfile" >&2
exit 3
fi
session=`getsession "$config"`
if ! [ -d "${session}" ] ; then
echo "cannot find readable session directory ${session} from config ${config}. check permissions" | tee -a "$logfile" >&2
exit 3
fi
}
d_start() {
[ -d "${base}" ] && cd "${base}"
stty stop undef && stty start undef
# robert 20080807 su -c "screen -ls | grep -sq "\.${srnname}[[:space:]]" " ${user} || su -c "screen -dm -S ${srnname} 2>&1 1>/dev/null" ${user} | tee -a "$logfile" >&2
su -c "screen -ls | grep -sq "\.${srnname}[[:space:]]" " ${user} || su -c "screen -dm -S ${srnname} " ${user}
# this works for the screen command, but starting rtorrent below adopts screen session gid
# even if it is not the screen session we started (e.g. running under an undesirable gid
#su -c "screen -ls | grep -sq "\.${srnname}[[:space:]]" " ${user} || su -c "sg \"$group\" -c \"screen -fn -dm -S ${srnname} 2>&1 1>/dev/null\"" ${user} | tee -a "$logfile" >&2
# robert 20080807 su -c "screen -S "${srnname}" -X screen rtorrent ${options} 2>&1 1>/dev/null" ${user} | tee -a "$logfile" >&2
su -c "screen -S "${srnname}" -X screen rtorrent ${options}" ${user}
}
d_stop() {
session=`getsession "$config"`
if ! [ -s ${session}/rtorrent.lock ] ; then
return
fi
pid=`cat ${session}/rtorrent.lock | awk -F: '{print($2)}' | sed "s/[^0-9]//g"`
if ps -A | grep -sq ${pid}.*rtorrent ; then # make sure the pid doesn't belong to another process
kill -s INT ${pid}
fi
}
getsession() {
session=`awk '/^[[:space:]]*session[[:space:]]*=[[:space:]]*/{print($3)}' "$config"`
echo $session
}
checkcnfg
case "$1" in
start)
echo -n "Starting $DESC: $NAME"
d_start
echo "."
;;
stop)
echo -n "Stopping $DESC: $NAME"
d_stop
echo "."
;;
restart|force-reload)
echo -n "Restarting $DESC: $NAME"
d_stop
sleep 1
d_start
echo "."
;;
*)
echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
exit 1
;;
esac
exit 0
Guardamos y salimos
Ahora actualizamos “update-rc.d”:
$ update-rc.d rtorrent defaults 25
3. Creamos un Usuario para rtorrent:
$ sudo adduser --disabled-login rtorrent $ sudo usermod -aG tty rtorrent $ sudo su - rtorrent
Creamos el archivo de configuración de rtorrent:
$ touch /home/rtorrent/.rtorrent.rc $ nano /home/rtorrent/.rtorrent.rc
# This is an example resource file for rTorrent. Copy to # ~/.rtorrent.rc and enable/modify the options as needed. Remember to # uncomment the options you wish to enable. # Maximum and minimum number of peers to connect to per torrent. min_peers = 40 max_peers = 100 # Same as above but for seeding completed torrents (-1 = same as downloading) min_peers_seed = 10 max_peers_seed = 50 # Maximum number of simultanious uploads per torrent. max_uploads = 10 # Global upload and download rate in KiB. "0" for unlimited. download_rate = 200 upload_rate = 20 # Default directory to save the downloaded torrents. directory = /home/rtorrent/temp/ # Default session directory. Make sure you don't run multiple instance # of rtorrent using the same session directory. Perhaps using a # relative path? session = /home/rtorrent/session/ # Watch a directory for new torrents, and stop those that have been # deleted. #schedule = watch_directory,5,5,load_start=./watch/*.torrent #schedule = untied_directory,5,5,stop_untied= schedule = watch_directory,10,10,load_start=/var/www/wtorrent/torrents/*.torrent schedule = tied_directory,10,10,start_tied= schedule = untied_directory,10,10,close_untied= # Close torrents when diskspace is low. schedule = low_diskspace,5,60,close_low_diskspace=100M # Stop torrents when reaching upload ratio in percent, # when also reaching total upload in bytes, or when # reaching final upload ratio in percent. # example: stop at ratio 2.0 with at least 200 MB uploaded, or else ratio 20.0 #schedule = ratio,60,60,"stop_on_ratio=200,200M,2000" schedule = ratio,60,60,"stop_on_ratio=100" # The ip address reported to the tracker. #ip = 127.0.0.1 #ip = rakshasa.no # The ip address the listening socket and outgoing connections is # bound to. #bind = 127.0.0.1 #bind = rakshasa.no # Port range to use for listening. #port_range = 6890-6999 port_range = 63963-63981 # Start opening ports at a random position within the port range. port_random = no # Check hash for finished torrents. Might be usefull until the bug is # fixed that causes lack of diskspace not to be properly reported. check_hash = yes # Set whetever the client should try to connect to UDP trackers. use_udp_trackers = yes # Alternative calls to bind and ip that should handle dynamic ip's. #schedule = ip_tick,0,1800,ip=rakshasa #schedule = bind_tick,0,1800,bind=rakshasa # Encryption options, set to none (default) or any combination of the following: # allow_incoming, try_outgoing, require, require_RC4, enable_retry, prefer_plaintext # # The example value allows incoming encrypted connections, starts unencrypted # outgoing connections but retries with encryption if they fail, preferring # plaintext to RC4 encryption after the encrypted handshake # # encryption = allow_incoming,enable_retry,prefer_plaintext encryption = allow_incoming,try_outgoing,enable_retry # Enable DHT support for trackerless torrents or when all trackers are down. # May be set to "disable" (completely disable DHT), "off" (do not start DHT), # "auto" (start and stop DHT as needed), or "on" (start DHT immediately). # The default is "off". For DHT to work, a session directory must be defined. # dht = auto # UDP port to use for DHT. # # dht_port = 6881 dht_port = 63982 # Enable peer exchange (for torrents not marked private) # peer_exchange = yes # # Do not modify the following parameters unless you know what you're doing. # # Hash read-ahead controls how many MB to request the kernel to read # ahead. If the value is too low the disk may not be fully utilized, # while if too high the kernel might not be able to keep the read # pages in memory thus end up trashing. #hash_read_ahead = 10 # Interval between attempts to check the hash, in milliseconds. #hash_interval = 100 # Number of attempts to check the hash while using the mincore status, # before forcing. Overworked systems might need lower values to get a # decent hash checking rate. #hash_max_tries = 10 # robert 20080805 scgi_port = localhost:5000
$ mkdir /home/rtorrent/session $ mkdir /home/rtorrent/session/temp $ screen rtorrent (pulsar "ctrl+a, d" para salir de rtorrent sin cerrarlo) $ logout
Modifica el archivo “.rtorrent.rc”, según tus necesidades, (yo he puesto la carpeta de descargas en “/var/www/wtorrent/downloads”, porque así después de instalar wtorrent y crear esa carpeta podré acceder a las descargas desde otros equipos en mi red poniendo “http://miIp:81/wtorrent/downloads”, (teniendo en cuenta que lighttpd lo tengo en el puerto 81))
4. Configurar Lighttpd
Editar el archivo de configuración de lighttpd y descomentar (eliminando # del principio) la linea que pone “mod_scgi”
$ sudo nano /etc/lighttpd/lighttpd.conf
sustituir “# mod_scgi” por “ mod_scgi”
Guardar y salir
Creamos un archivo de configuración de scgi para lighttpd:
$ sudo touch /etc/lighttpd/conf-available/10-scgi.conf
y le añadimos el siguiente contenido:
scgi.server = ( "/RPC2" => # Rtorrent_DIR ( "127.0.0.1" => ( "host" => "127.0.0.1", # Ip where rtorrent is listening "port" => 5000, # Port specified in .rtorrent.rc "check-local" => "disable" ) ) )
Activamos la configuración que acabamos de crear con symlinks:
$ sudo cd /etc/lighttpd/conf-enabled/ $ sudo ln -s ../conf-available/10-cgi.conf . $ sudo ln -s ../conf-available/10-scgi.conf .
Reiniciamos Lighttpd:
$ sudo /etc/init.d/lighttpd restart
5. Instalamos Wtorrent
$ cd /var/www/ $ sudo svn checkout http://wtorrent-project.googlecode.com/svn/trunk/ wtorrent-project-read-only $ sudo mv ./wtorrent-project-read-only/wtorrent ./wtorrent $ sudo rm -rf ./wtorrent-project-read-only $ sudo chown -R www-data:www-data wtorrent $ sudo chmod -R 777 wtorrent
Ahora abrimos un navegador y vamos a la pagina “http://localhost:81/wtorrent/install.php”, cubrimos la información requerida y guardamos.
- el campo “/RPC2″, dejarlo como esta
- el puerto del scgi, es el puerto de lighttpd, (en mi caso es el 81)
- podemos verificar nuestros datos poniendo en una url “http://localhost:puerto/RPC2″, ej: “http://localhost:81/RPC2″, y si la pagina esta totalmente en blanco es que la carpeta es accesible
Ahora restringimos los permisos y invalidamos install.php
$ sudo chmod -R 755 /var/www/wtorrent $ sudo chmod -R 777 /var/www/wtorrent/downloads /var/www/wtorrent/torrents $ mv install.php install.php_deactivated
y ya deberías poder acceder a wtorrent vía “http://tuIp:puerto/wtorrent”, ej: “http://127.0.0.1:81/wtorrent”
